<?php

namespace ATDConnect\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for criteriaType StructType
 * @subpackage Structs
 */
class CriteriaType extends AbstractStructBase
{
    /**
     * The entry
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \ATDConnect\StructType\CriteriaEntryType[]
     */
    public $entry;
    /**
     * Constructor method for criteriaType
     * @uses CriteriaType::setEntry()
     * @param \ATDConnect\StructType\CriteriaEntryType[] $entry
     */
    public function __construct(array $entry = array())
    {
        $this
            ->setEntry($entry);
    }
    /**
     * Get entry value
     * @return \ATDConnect\StructType\CriteriaEntryType[]|null
     */
    public function getEntry()
    {
        return $this->entry;
    }
    /**
     * This method is responsible for validating the values passed to the setEntry method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEntry method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEntryForArrayConstraintsFromSetEntry(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $criteriaTypeEntryItem) {
            // validation for constraint: itemType
            if (!$criteriaTypeEntryItem instanceof \ATDConnect\StructType\CriteriaEntryType) {
                $invalidValues[] = is_object($criteriaTypeEntryItem) ? get_class($criteriaTypeEntryItem) : sprintf('%s(%s)', gettype($criteriaTypeEntryItem), var_export($criteriaTypeEntryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The entry property can only contain items of type \ATDConnect\StructType\CriteriaEntryType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set entry value
     * @throws \InvalidArgumentException
     * @param \ATDConnect\StructType\CriteriaEntryType[] $entry
     * @return \ATDConnect\StructType\CriteriaType
     */
    public function setEntry(array $entry = array())
    {
        // validation for constraint: array
        if ('' !== ($entryArrayErrorMessage = self::validateEntryForArrayConstraintsFromSetEntry($entry))) {
            throw new \InvalidArgumentException($entryArrayErrorMessage, __LINE__);
        }
        $this->entry = $entry;
        return $this;
    }
    /**
     * Add item to entry value
     * @throws \InvalidArgumentException
     * @param \ATDConnect\StructType\CriteriaEntryType $item
     * @return \ATDConnect\StructType\CriteriaType
     */
    public function addToEntry(\ATDConnect\StructType\CriteriaEntryType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ATDConnect\StructType\CriteriaEntryType) {
            throw new \InvalidArgumentException(sprintf('The entry property can only contain items of type \ATDConnect\StructType\CriteriaEntryType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->entry[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ATDConnect\StructType\CriteriaType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
