<?php

namespace ATDConnect\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for marketingProduct StructType
 * @subpackage Structs
 */
class MarketingProduct extends Product
{
    /**
     * The marketing
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ATDConnect\StructType\Marketing
     */
    public $marketing;
    /**
     * Constructor method for marketingProduct
     * @uses MarketingProduct::setMarketing()
     * @param \ATDConnect\StructType\Marketing $marketing
     */
    public function __construct(\ATDConnect\StructType\Marketing $marketing = null)
    {
        $this
            ->setMarketing($marketing);
    }
    /**
     * Get marketing value
     * @return \ATDConnect\StructType\Marketing|null
     */
    public function getMarketing()
    {
        return $this->marketing;
    }
    /**
     * Set marketing value
     * @param \ATDConnect\StructType\Marketing $marketing
     * @return \ATDConnect\StructType\MarketingProduct
     */
    public function setMarketing(\ATDConnect\StructType\Marketing $marketing = null)
    {
        $this->marketing = $marketing;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ATDConnect\StructType\MarketingProduct
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
