<?php

namespace ATDConnect\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for responseImageTypes StructType
 * @subpackage Structs
 */
class ResponseImageTypes extends AbstractStructBase
{
    /**
     * The thumbnail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ATDConnect\StructType\ResponseImages
     */
    public $thumbnail;
    /**
     * The small
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ATDConnect\StructType\ResponseImages
     */
    public $small;
    /**
     * The large
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ATDConnect\StructType\ResponseImages
     */
    public $large;
    /**
     * Constructor method for responseImageTypes
     * @uses ResponseImageTypes::setThumbnail()
     * @uses ResponseImageTypes::setSmall()
     * @uses ResponseImageTypes::setLarge()
     * @param \ATDConnect\StructType\ResponseImages $thumbnail
     * @param \ATDConnect\StructType\ResponseImages $small
     * @param \ATDConnect\StructType\ResponseImages $large
     */
    public function __construct(\ATDConnect\StructType\ResponseImages $thumbnail = null, \ATDConnect\StructType\ResponseImages $small = null, \ATDConnect\StructType\ResponseImages $large = null)
    {
        $this
            ->setThumbnail($thumbnail)
            ->setSmall($small)
            ->setLarge($large);
    }
    /**
     * Get thumbnail value
     * @return \ATDConnect\StructType\ResponseImages|null
     */
    public function getThumbnail()
    {
        return $this->thumbnail;
    }
    /**
     * Set thumbnail value
     * @param \ATDConnect\StructType\ResponseImages $thumbnail
     * @return \ATDConnect\StructType\ResponseImageTypes
     */
    public function setThumbnail(\ATDConnect\StructType\ResponseImages $thumbnail = null)
    {
        $this->thumbnail = $thumbnail;
        return $this;
    }
    /**
     * Get small value
     * @return \ATDConnect\StructType\ResponseImages|null
     */
    public function getSmall()
    {
        return $this->small;
    }
    /**
     * Set small value
     * @param \ATDConnect\StructType\ResponseImages $small
     * @return \ATDConnect\StructType\ResponseImageTypes
     */
    public function setSmall(\ATDConnect\StructType\ResponseImages $small = null)
    {
        $this->small = $small;
        return $this;
    }
    /**
     * Get large value
     * @return \ATDConnect\StructType\ResponseImages|null
     */
    public function getLarge()
    {
        return $this->large;
    }
    /**
     * Set large value
     * @param \ATDConnect\StructType\ResponseImages $large
     * @return \ATDConnect\StructType\ResponseImageTypes
     */
    public function setLarge(\ATDConnect\StructType\ResponseImages $large = null)
    {
        $this->large = $large;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ATDConnect\StructType\ResponseImageTypes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
