<?php

namespace ATDConnect\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for responseImages StructType
 * Meta information extracted from the WSDL
 * - mixed: true
 * @subpackage Structs
 */
class ResponseImages extends AbstractStructBase
{
    /**
     * The images
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \ATDConnect\StructType\Images[]
     */
    public $images;
    /**
     * Constructor method for responseImages
     * @uses ResponseImages::setImages()
     * @param \ATDConnect\StructType\Images[] $images
     */
    public function __construct(array $images = array())
    {
        $this
            ->setImages($images);
    }
    /**
     * Get images value
     * @return \ATDConnect\StructType\Images[]|null
     */
    public function getImages()
    {
        return $this->images;
    }
    /**
     * This method is responsible for validating the values passed to the setImages method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImages method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImagesForArrayConstraintsFromSetImages(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $responseImagesImagesItem) {
            // validation for constraint: itemType
            if (!$responseImagesImagesItem instanceof \ATDConnect\StructType\Images) {
                $invalidValues[] = is_object($responseImagesImagesItem) ? get_class($responseImagesImagesItem) : sprintf('%s(%s)', gettype($responseImagesImagesItem), var_export($responseImagesImagesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The images property can only contain items of type \ATDConnect\StructType\Images, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set images value
     * @throws \InvalidArgumentException
     * @param \ATDConnect\StructType\Images[] $images
     * @return \ATDConnect\StructType\ResponseImages
     */
    public function setImages(array $images = array())
    {
        // validation for constraint: array
        if ('' !== ($imagesArrayErrorMessage = self::validateImagesForArrayConstraintsFromSetImages($images))) {
            throw new \InvalidArgumentException($imagesArrayErrorMessage, __LINE__);
        }
        $this->images = $images;
        return $this;
    }
    /**
     * Add item to images value
     * @throws \InvalidArgumentException
     * @param \ATDConnect\StructType\Images $item
     * @return \ATDConnect\StructType\ResponseImages
     */
    public function addToImages(\ATDConnect\StructType\Images $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ATDConnect\StructType\Images) {
            throw new \InvalidArgumentException(sprintf('The images property can only contain items of type \ATDConnect\StructType\Images, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->images[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \ATDConnect\StructType\ResponseImages
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
